/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "pfgroup.h"
#include "csman.h"


static unsigned char obindex;
static unsigned char ibindex;
/* 
 * pfgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid pfgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,7 };


/* 
 * variable4 pfgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the pfgroup mib section 
 */


struct variable4 pfgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { OBFILTERSWITCH      , ASN_INTEGER   , RWRITE, var_pfgroup, 1, { 1 } },
  { OBMODE              , ASN_INTEGER   , RWRITE, var_pfgroup, 1, { 2 } },
  { OBSOURCEIP          , ASN_IPADDRESS , RWRITE, var_oBTable, 3, { 3,1,1 } },
  { OBSOURCEPORT        , ASN_OCTET_STR , RWRITE, var_oBTable, 3, { 3,1,2 } },
  { OBDESTIP            , ASN_IPADDRESS , RWRITE, var_oBTable, 3, { 3,1,3 } },
  { OBDESTPORT          , ASN_OCTET_STR , RWRITE, var_oBTable, 3, { 3,1,4 } },
  { OBRULESWITCH        , ASN_INTEGER   , RWRITE, var_oBTable, 3, { 3,1,5 } },
  { OBRULESCHEDULE      , ASN_INTEGER   , RWRITE, var_oBTable, 3, { 3,1,6 } },
  { OBINDEX             , ASN_INTEGER   , RWRITE, var_oBTable, 3, { 3,1,7 } },
  { IBFILTERSWITCH      , ASN_INTEGER   , RWRITE, var_pfgroup, 1, { 4 } },
  { IBMODE              , ASN_INTEGER   , RWRITE, var_pfgroup, 1, { 5 } },
  { IBSOURCEIP          , ASN_IPADDRESS , RWRITE, var_iBTable, 3, { 6,1,1 } },
  { IBSOURCEPORT        , ASN_OCTET_STR , RWRITE, var_iBTable, 3, { 6,1,2 } },
  { IBDESTIP            , ASN_IPADDRESS , RWRITE, var_iBTable, 3, { 6,1,3 } },
  { IBDESTPORT          , ASN_OCTET_STR , RWRITE, var_iBTable, 3, { 6,1,4 } },
  { IBRULESWITCH        , ASN_INTEGER   , RWRITE, var_iBTable, 3, { 6,1,5 } },
  { IBRULESCHEDULE      , ASN_INTEGER   , RWRITE, var_iBTable, 3, { 6,1,6 } },
  { IBINDEX             , ASN_INTEGER   , RWRITE, var_iBTable, 3, { 6,1,7 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_pfgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_pfgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/pfgroup", pfgroup_variables, variable4,
               pfgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_pfgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_pfgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case IBMODE:
		{
			*write_method = write_iBmode;
			int ret = 0;
			int fd=0;
			unsigned char ibmode;
			ret = read_csman(fd,0x000e0004,&ibmode,sizeof(unsigned char),TYPE_U32);
			long_ret =  ibmode;
			return (unsigned char *) &long_ret;
		}

    case IBFILTERSWITCH:
		{
			*write_method = write_iBfilterSwitch;
			int ret = 0;
			int fd=0;
			unsigned char ibfilter_switch;
			ret = read_csman(fd,0x000e0002,&ibfilter_switch,sizeof(unsigned char),TYPE_U32);
			long_ret =  ibfilter_switch;
			return (unsigned char *) &long_ret;
		}

    case OBMODE:
		{
			*write_method = write_oBmode;
			int ret = 0;
			int fd=0;
			unsigned char ibmode;
			ret = read_csman(fd,0x000e0003,&ibmode,sizeof(unsigned char),TYPE_U32);
			long_ret =  ibmode;
			return (unsigned char *) &long_ret;
		}

    case OBFILTERSWITCH:
		{
			*write_method = write_oBfilterSwitch;
			int ret = 0;
			int fd=0;
			unsigned char obfilter_switch;
			ret = read_csman(fd,0x000e0001,&obfilter_switch,sizeof(unsigned char),TYPE_U32);
			long_ret =  obfilter_switch;
			return (unsigned char *) &long_ret;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_oBTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_pfgroup above.
 */
unsigned char *
var_oBTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;

  memset(string,0,sizeof(string));

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case OBINDEX:
		{
			*write_method = write_oBindex;
			long_ret = obindex;
			return (unsigned char *) &long_ret;
		}

    case OBRULESCHEDULE:
		{
			*write_method = write_oBRuleSchedule;
			int ret = 0;
			int fd=0;
			unsigned char rule_sch;
			ret = read_csman(fd,0x000e5800+obindex,&rule_sch,sizeof(unsigned char),TYPE_U32);
			long_ret =  rule_sch;
			return (unsigned char *) &long_ret;
		}

    case OBRULESWITCH:
		{
			*write_method = write_oBRuleSwitch;
			int ret = 0;
			int fd=0;
			unsigned char obrule_switch;
			ret = read_csman(fd,0x000e1000+obindex,&obrule_switch,sizeof(unsigned char),TYPE_U32);
			long_ret =  obrule_switch;
			return (unsigned char *) &long_ret;
		}

    case OBDESTPORT:
		{
			*write_method = write_oBDestPort;
			int ret = 0;
			int fd=0;
			unsigned char obdestport[512];
			
			memset(obdestport,0,sizeof(obdestport));
			ret = read_csman(fd,0x000e4800+obindex,obdestport,sizeof(obdestport),TYPE_STR);
	
			strcpy(string,obdestport);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case OBDESTIP:
		{
			*write_method = write_oBDestIP;
			int ret = 0;
			int fd=0;
			unsigned char obdest_ip[4];
			memset(obdest_ip,0,sizeof(obdest_ip));
			ret = read_csman (fd,0x000e3800+obindex,obdest_ip,sizeof(obdest_ip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=obdest_ip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case OBSOURCEPORT:
		{
			*write_method = write_oBSourcePort;
			int ret = 0;
			int fd=0;
			unsigned char obsrcport[512];
			
			memset(obsrcport,0,sizeof(obsrcport));
			ret = read_csman(fd,0x000e2800+obindex,obsrcport,sizeof(obsrcport),TYPE_STR);
	
			strcpy(string,obsrcport);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case OBSOURCEIP:
		{
			*write_method = write_oBSourceIP;
			int ret = 0;
			int fd=0;
			unsigned char obsrc_ip[4];
			memset(obsrc_ip,0,sizeof(obsrc_ip));
			ret = read_csman(fd,0x000e1800+obindex,obsrc_ip,sizeof(obsrc_ip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=obsrc_ip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}


unsigned char *
var_iBTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;

  memset(string,0,sizeof(string));

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case IBINDEX:
		{
			*write_method = write_iBindex;
			long_ret = ibindex;
			return (unsigned char *) &long_ret;
		}

    case IBRULESCHEDULE:
		{
			*write_method = write_iBRuleSchedule;
			int ret = 0;
			int fd=0;
			unsigned char rule_sch;
			ret = read_csman(fd,0x000ed800+ibindex,&rule_sch,sizeof(unsigned char),TYPE_U32);
			long_ret =  rule_sch;
			return (unsigned char *) &long_ret;
		}

    case IBRULESWITCH:
		{
			*write_method = write_iBRuleSwitch;
			int ret = 0;
			int fd=0;
			unsigned char ibrule_switch;
			ret = read_csman(fd,0x000e9000+ibindex,&ibrule_switch,sizeof(unsigned char),TYPE_U32);
			long_ret =  ibrule_switch;
			return (unsigned char *) &long_ret;
		}

    case IBDESTPORT:
		{
			*write_method = write_iBDestPort;
			int ret = 0;
			int fd=0;
			unsigned char ibdestport[512];
			
			memset(ibdestport,0,sizeof(ibdestport));
			ret = read_csman(fd,0x000ec800+ibindex,ibdestport,sizeof(ibdestport),TYPE_STR);
	
			strcpy(string,ibdestport);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case IBDESTIP:
		{
			*write_method = write_iBDestIP;
			int ret = 0;
			int fd=0;
			unsigned char ibdest_ip[4];
			memset(ibdest_ip,0,sizeof(ibdest_ip));
			ret = read_csman (fd,0x000eb800+ibindex,ibdest_ip,sizeof(ibdest_ip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=ibdest_ip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case IBSOURCEPORT:
		{
			*write_method = write_iBSourcePort;
			int ret = 0;
			int fd=0;
			unsigned char ibsrcport[512];
			
			memset(ibsrcport,0,sizeof(ibsrcport));
			ret = read_csman(fd,0x000ea800+ibindex,ibsrcport,sizeof(ibsrcport),TYPE_STR);
	
			strcpy(string,ibsrcport);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case IBSOURCEIP:
		{
			*write_method = write_iBSourceIP;
			int ret = 0;
			int fd=0;
			unsigned char ibsrc_ip[4];
			memset(ibsrc_ip,0,sizeof(ibsrc_ip));
			ret = read_csman(fd,0x000e9800+ibindex,ibsrc_ip,sizeof(ibsrc_ip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=ibsrc_ip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}


int
write_iBindex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to iBindex not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to iBindex: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  ibindex = long_ret;
			  printf("ibindex = %d\n",ibindex);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBRuleSchedule(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBRuleSchedule not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBRuleSchedule: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000ed800+ibindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBRuleSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to iBRuleSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to iBRuleSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e9000+ibindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBDestPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to iBDestPort not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to iBDestPort: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x000ec800+ibindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBDestIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to iBDestIP not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to iBDestIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x000eb800+ibindex,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBSourcePort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static	unsigned char string[SPRINT_MAX_LEN];
	int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to iBSourcePort not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to iBSourcePort: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x000ea800+ibindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBSourceIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to iBSourceIP not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to iBSourceIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x000e9800+ibindex,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBmode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to iBmode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to iBmode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e0004,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_iBfilterSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBfilterSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBfilterSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e0002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBindex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBindex not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBindex: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  obindex = long_ret;
			  printf("obindex = %d\n",obindex);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBRuleSchedule(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBRuleSchedule not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBRuleSchedule: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e5800+obindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBRuleSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBRuleSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBRuleSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e1000+obindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBDestPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static	unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to oBDestPort not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to oBDestPort: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x000e4800+obindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBDestIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static   unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to oBDestIP not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to oBDestIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x000e3800+obindex,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBSourcePort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to oBSourcePort not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to oBSourcePort: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x000e2800+obindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBSourceIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to oBSourceIP not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to oBSourceIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x000e1800+obindex,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBmode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBmode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBmode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e0003,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_oBfilterSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to oBfilterSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to oBfilterSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000e0001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






