#!/bin/sh
#
# snmpd.sh                     This script do a action of snmp
#

LANIF=br0

#~    !!!! ($S_LOCAL_WAN_IF_NAME/str/)
WANIF=eth1  #$dev_wan_interface

#~~     if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~             if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS != 2) {
#~                           !!!! ($S_FAILOVER_WAN_IF_NAME/str/)
                       WANIF=eth1  #$dev_wan_interface
#~~             }
#~~             if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                    if ($S_FAILOVER_STATUS == 2) {
#~                                         !!!! ($S_FAILOVER_WAN_IF_NAME/str/)
                              SECOND_WANIF=eth1  #$dev_wan_interface
#~~                    }
#~~             }
#~~     }

#~       !!!!!!! ($C_SNMP_WAN_ACCESS_IP/str/)
SNMP_WAN=a.b.c.d

start() {
	local err; err=0
	echo -n "start snmpd.sh ..."

#~~     if ($C_SNMP_LOCAL_ENABLE != 1) {
		iptables -t filter -A INPUT -i $LANIF -p udp --dport 161 -j DROP
#~~     }

#~~     if ($C_SNMP_REMOTE_ENABLE != 1) {
		iptables -t filter -A INPUT -i $WANIF -p udp --dport 161 -j DROP
#~~             if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                    if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                           if ($S_FAILOVER_STATUS == 2) {
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport 161 -j DROP
#~~                           }
#~~                    }
#~~             }
#~~     } else { 
#~~             if ($C_SNMP_WAN_ACCESS_IP != None) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport 161 -j ACCEPT &&
		iptables -t filter -A INPUT -i $WANIF -p udp --dport 161 -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -A INPUT -i $WANIF -p udp --dport 161 -j ACCEPT
#~~                    if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                           if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                                  if ($S_FAILOVER_STATUS == 2) {
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -A INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport 161 -j ACCEPT &&
		iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport 161 -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -A INPUT -i $SECOND_WANIF -p udp --dport 161 -j ACCEPT
#~~                                  }
#~~                           }
#~~                    }
#~~             }	
#~~     }
	
	return $err
}

stop() {
	local err; err=0
    echo -n "stop snmpd.sh ..."

#~~     if ($C_SNMP_LOCAL_ENABLE != 1) {
        iptables -t filter -D INPUT -i $LANIF -p udp --dport 161 -j DROP
#~~     }

#~~     if ($C_SNMP_REMOTE_ENABLE != 1) {
        iptables -t filter -D INPUT -i $WANIF -p udp --dport 161 -j DROP
#~~             if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                    if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                           if ($S_FAILOVER_STATUS == 2) {
		iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport 161 -j DROP
#~~                           }
#~~                    }
#~~             }
#~~     } else {
#~~             if ($C_SNMP_WAN_ACCESS_IP != None) {
test $SNMP_WAN != "0.0.0.0" &&
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $WANIF -s 192.168.xxx.xxx -p udp --dport 161 -j ACCEPT &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport 161 -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $WANIF -p udp --dport 161 -j ACCEPT
#~~                    if ($C_FAILOVER_LOADSHARING_ENABLE == 1) {
#~~                           if ($S_FAILOVER_LOADSHARING_FIRST_CNT_STATUS == 2) {
#~~                                  if ($S_FAILOVER_STATUS == 2) {
#~                                               !!!!!!!!!!!!!!! ($C_SNMP_WAN_ACCESS_IP/str)
        iptables -t filter -D INPUT -i $SECOND_WANIF -s 192.168.xxx.xxx -p udp --dport 161 -j ACCEPT &&
		iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport 161 -j DROP
test $SNMP_WAN = "0.0.0.0" &&
        iptables -t filter -D INPUT -i $SECOND_WANIF -p udp --dport 161 -j ACCEPT
#~~                                  }
#~~                           }
#~~                    }
#~~             }
#~~     }
	
	return $err
}

usage() {
	echo "$0 [start|stop|restart|reload|config]"
	exit 1
}

# +++++++++++++++ main ++++++++++++++++++++++ 
[ -z "$1" ] && usage;

err=0

case "$1" in
	config)		;;
	start)		start;;
	stop)		stop;;
	reload)		;;
	restart)	stop; start;;
	*)		usage;;
esac
if [ $? = "0" ] ; then
	echo $0 $@ ok
else
	echo $0 $@ error
	err=1
fi

exit $err
